config/routes.rb
Rails.application.routes.draw do
  root 'sessions#new'

  get 'login' => 'sessions#new', as: :login
  post 'login' => 'sessions#create'
  delete 'logout' => 'sessions#destroy', as: :logout
  get 'logout' => 'sessions#destroy'
  resources 'account_activations', only: [:edit]
  resources 'password_resets', only: [:new, :edit, :create, :update]

  get 'users' => 'users#index', as: :users
  get 'signup' => 'users#new', as: :signup
  post 'users' => 'users#create'
  get ':username' => 'users#show', as: :user
  get ':username/edit' => 'users#edit', as: :edit_user
  patch ':username' => 'users#update'
  put ':username' => 'users#update'
  delete ':username' => 'users#destroy'

end

app/models/user.rb
class User < ActiveRecord::Base
	attr_accessor	:remember_token, :activation_token, :reset_token
	before_save :downcase_email
	before_save :downcase_username
	before_create :create_activation_digest

	validates :name, presence: true, length: { in: 2..50 }
	validates :username, presence: true, length: { in: 7..11 }, uniqueness: { case_sensitive: false }
	VALID_EMAIL_REGEX	=	/\A[\w+\-.]+@[a-z\d\-.]+\.[a-z]+\z/i
	validates :email, presence: true, length: { maximum: 255 }, format: { with: VALID_EMAIL_REGEX }, uniqueness: { case_sensitive: false }

	has_secure_password
	validates :password, length: { minimum: 8 }, allow_blank: true

	def User.digest(string)
		cost = ActiveModel::SecurePassword.min_cost ? BCrypt::Engine::MIN_COST : BCrypt::Engine.cost
		BCrypt::Password.create(string, cost: cost)
	end

	def User.new_token
		SecureRandom.urlsafe_base64
	end

	def remember
		self.remember_token = User.new_token
		update_attribute(:remember_digest, User.digest(remember_token))
	end

	def authenticated?(attribute, token)
		digest = send("#{attribute}_digest")
		return false if digest.nil?
		BCrypt::Password.new(digest).is_password?(token)
	end

	def forget
		update_attribute(:remember_digest, nil)
	end

	def activate
		update_attribute(:activated, true)
		update_attribute(:activated_at, Time.zone.now)
	end

	def send_activation_email
		UserMailer.account_activation(self).deliver_now
	end

	def create_reset_digest
		self.reset_token = User.new_token
		update_attribute(:reset_digest, User.digest(reset_token))
		update_attribute(:reset_sent_at, Time.zone.now)
	end

	def send_password_reset_email
		UserMailer.password_reset(self).deliver_now
	end

	def password_reset_expired?
		reset_sent_at < 2.hours.ago
	end

	def to_param
	  username
	end

	private

		def downcase_email
			self.email = email.downcase
		end

		def downcase_username
			self.username = username.downcase
		end

		def create_activation_digest
			self.activation_token = User.new_token
			self.activation_digest = User.digest(activation_token)
		end
end

app/controllers/account_activations_controller.rb
class AccountActivationsController < ApplicationController

	def edit
		user = User.find_by(username: params[:username])
		if user && !user.activated? && user.authenticated?(:activation, params[:id])
			user.activate
			log_in(user)
			flash[:success] = "Your account has successfully been activated"
			redirect_to user
		else
			flash[:danger] = "The link is invalid"
			redirect_to root_url
		end
	end

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
  include SessionsHelper
end

app/controllers/password_resets_controller.rb
class PasswordResetsController < ApplicationController
	before_action :get_user, only: [:edit, :update]
	before_action :valid_user, only: [:edit, :update]
	before_action :check_expiration, only: [:edit, :update]

  def new
  end

  def create
  	@user = User.find_by(username: params[:password_reset][:username].downcase)
  	if @user
  		@user.create_reset_digest
  		@user.send_password_reset_email
      flash[:info] = "Check your email"
  		redirect_to root_url
  	else
      flash[:danger] = "The username provided does not exist"
  		render 'new'
  	end
  end

  def edit
  end

  def update
  	if password_blank?
      flash[:danger] = "Please provide a valid password"
  		render 'edit'
  	elsif @user.update_attributes(user_params)
  		log_in @user
      flash[:success] = "Password successfuly updated"
  		redirect_to @user
  	else
      flash[:danger] = "Issues"
  		render 'edit'
  	end
  end

  private
  	def user_params
  		params.require(:user).permit(:password, :password_confirmation)
  	end

  	def password_blank?
  		params[:user][:password].blank?
  	end

  	def get_user
  		@user = User.find_by(username: params[:username].downcase)
  	end

  	def valid_user
  		unless (@user && @user.activated? && @user.authenticated?(:reset, params[:id]))
        flash[:danger] = "Sorry, but you're not allowed"
  			redirect_to root_url
  		end
  	end

  	def check_expiration
  		if @user.password_reset_expired?
        flash[:danger] = "The link has expired"
  			redirect_to new_password_reset_url
  		end
  	end

end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  def new
  end

  def create
  	user = User.find_by(username: params[:session][:username].downcase)
  	if user && user.authenticate(params[:session][:password])
  		if user.activated?
        log_in user
        params[:session][:remember_me]  ==  '1' ? remember(user)  : forget(user)
        flash[:success] = "You have successfully logged in :)" 
        redirect_back_or user
      else
        flash[:danger] = "Please activate your account"
        redirect_to root_url
      end
  	else
      flash[:danger] = "The username and/or password provided is/are incorrect"
  		render 'new'
  	end
  end

  def destroy
  	log_out if logged_in?
    flash[:success] = "You have successfully logged out."
  	redirect_to root_url
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:show, :edit, :update, :destroy]
  before_action :logged_in_user, only: [:show, :edit, :update, :destroy]
  before_action :correct_user, only: [:edit, :update, :destroy]

  def index
    @users = User.paginate(page: params[:page])
  end

  def show
  end

  def new
    @user = User.new
  end

  def create
    @user = User.new(user_params)
    if @user.save
      @user.send_activation_email
      flash[:success] = "Your account has successfuly been created"
      flash[:info] = "Please check your email"
      redirect_to root_url
    else
      render 'new'
    end
  end

  def edit
  end

  def update
    if @user.update_attributes(user_params_edit)
      flash[:success] = "Your account has successfuly been updated"
      redirect_to @user
    else
      render 'edit'
    end
  end

  def destroy
    @user.destroy
    redirect_to root_url
  end

  private
    def user_params
      params.require(:user).permit(:name, :username, :email, :password, :password_confirmation)
    end

    def user_params_edit
      params.require(:user).permit(:name, :username, :email)
    end

    def set_user
      @user = User.find_by(username: params[:username])
    end

    def logged_in_user
      unless logged_in?
        store_location
        flash[:danger] = "Please log in"
        redirect_to login_url
      end
    end

    def correct_user
      @user = User.find_by(username: params[:username])
      unless current_user?(@user)
        flash[:danger] = "You can't do that"
        redirect_to(root_url)
      end
    end
end

app/helpers/account_activations_helper.rb
module AccountActivationsHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/password_resets_helper.rb
module PasswordResetsHelper
end

app/helpers/sessions_helper.rb
module SessionsHelper
	def log_in(user)
		session[:user_id] = user.id
	end

	def remember(user)
		user.remember
		cookies.permanent.signed[:user_id] = user.id
		cookies.permanent[:remember_token] = user.remember_token
	end

	def current_user
		if (user_id = session[:user_id])
			@current_user ||= User.find_by(id: user_id)
		elsif (user_id = cookies.signed[:user_id])
			user = User.find_by(id: user_id)
			if user && user.authenticated?(:remember, cookies[:remember_token])
				log_in user
				@current_user = user
			end
		end
	end

	def logged_in?
		!current_user.nil?
	end

	def forget(user)
		user.forget
		cookies.delete(:user_id)
		cookies.delete(:remember_token)
	end

	def log_out
		forget(current_user)
		session.delete(:user_id)
		@current_user = nil
	end

	def current_user?(user)
		user == current_user
	end

	def redirect_back_or(default)
		redirect_to(session[:forwarding_url] || default)
		session.delete(:forwarding_url)
	end

	def store_location
		session[:forwarding_url] = request.url if request.get?
	end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>SsForApp</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>

<div class="flash_cont cont">
	<% flash.each do |message_type,	message| %>
		<div class="<%= message_type %>">
			<i class="fa fa-close"></i>
			<%= message %>
		</div>
	<% end %>
</div>

<%= yield %>

</body>
</html>

app/views/password_resets/edit.html.erb
<h1>Reset password</h1>
<div>
	<div>
		<%= form_for(@user, url: password_reset_path(params[:id])) do |f| %>
			<%= render 'shared/error_messages' %>

			<%= hidden_field_tag :username, @user.username %>

			<%= f.label :password %>
			<%= f.password_field :password, class: 'form-control' %>

			<%= f.label :password_confirmation, "Confirmation" %>
			<%= f.password_field :password_confirmation, class: 'form-control' %>

			<%= f.submit "Update password", class: "btn btn-primary" %>
		<% end %>
	</div>
</div>

app/views/password_resets/new.html.erb
<h1>Forgot password</h1>
<div>
	<div>
		<%= form_for(:password_reset, url: password_resets_path) do |f| %>
			<%= f.label :username %>
			<%= f.text_field :username, class: 'form-control' %>
			
			<%= f.submit "Submit", class: "btn btn-primary" %>
		<% end %>
	</div>
</div>

app/views/shared/_error_messages.html.erb
<% if @user.errors.any? %>
	<div>
		<div>
			The	form contains <%= pluralize(@user.errors.count,	"error") %>.
		</div>
		<ul>
		<% @user.errors.full_messages.each do |msg| %>
		<li><%= msg %></li>
		<% end %>
		</ul>
	</div>
<% end %>

app/views/users/edit.html.erb
<h1>Edit me</h1>
<div>
	<div>
		<%= form_for(@user) do |f| %>
			<%=	render 'shared/error_messages' %>

			<%=	f.label	:name %>
			<%=	f.text_field :name %>

			<%=	f.label	:username %>
			<%=	f.text_field :username %>

			<%=	f.label	:email %>
			<%=	f.email_field :email %>

			<%=	f.submit "Create my account", class: "btn btn-primary" %>
		<% end %>
	</div>
</div>

app/views/users/index.html.erb
<h1>All	users</h1>
<ul class="users">
	<% @users.each do |user| %>
		<li>
			<%= link_to user.name, "/"+user.username %>
		</li>
	<% end %>
</ul>

app/views/users/new.html.erb
<h1>Sign up</h1>
<div>
	<div>
		<%= form_for(@user) do |f| %>
			<%=	render 'shared/error_messages' %>

			<%=	f.label	:name %>
			<%=	f.text_field :name %>

			<%=	f.label	:username %>
			<%=	f.text_field :username %>

			<%=	f.label	:email %>
			<%=	f.email_field :email %>

			<%=	f.label	:password %>
			<%=	f.password_field :password %>

			<%=	f.label	:password_confirmation,	"Confirmation" %>
			<%=	f.password_field :password_confirmation %>
			
			<%=	f.submit "Create my account", class: "btn btn-primary" %>
		<% end %>
	</div>
</div>

app/views/users/show.html.erb
<h1><%=	@user.name	%></h1>
<h1><%=	@user.username	%></h1>
<h1><%=	@user.email	%></h1>